## libpappsomspp 0.2.35-1

=== CMakeLists.txt ===
# CMake script for PAPPSOms++ library
# Author: Olivier Langella
# Created: 03/03/2015

# Global parameters
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
PROJECT(pappsomspp CXX)

IF(NOT USEQT4)
  IF(NOT USEQT5)
    SET (USEQT4 1)
  ENDIF(NOT USEQT5)
ENDIF(NOT USEQT4)

IF(NOT CMAKE_BUILD_TYPE)
#  SET(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING
#      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
#      FORCE)
  SET(CMAKE_BUILD_TYPE Debug CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

MESSAGE("CMAKE_BUILD_TYPE : ${CMAKE_BUILD_TYPE}")

IF(CMAKE_BUILD_TYPE MATCHES "Release")
  MESSAGE("compiling as release version")
  ADD_DEFINITIONS("-DQT_NO_DEBUG_OUTPUT")
ENDIF( CMAKE_BUILD_TYPE MATCHES "Release" )

IF(CMAKE_BUILD_TYPE MATCHES "Debug")
  MESSAGE("compiling as debug version")
ENDIF( CMAKE_BUILD_TYPE MATCHES "Debug" )

IF(CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo")
  MESSAGE("compiling as release with debug info version")
ENDIF( CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo" )

#SET(CMAKE_CXX_FLAGS "-Wall -Weffc++ -Wshadow -Wconversion")
SET(CMAKE_CXX_FLAGS " ${CMAKE_CXX_FLAGS} -std=c++11")

SET(PAPPSOMSPP_VERSION_MAJOR "0")
SET(PAPPSOMSPP_VERSION_MINOR "2")
SET(PAPPSOMSPP_VERSION_PATCH "35")
SET(PAPPSOMSPP_VERSION "${PAPPSOMSPP_VERSION_MAJOR}.${PAPPSOMSPP_VERSION_MINOR}.${PAPPSOMSPP_VERSION_PATCH}")

# Set the CMAKE_PREFIX_PATH for the find_library fonction when using non
# standard install location
IF(CMAKE_INSTALL_PREFIX)
  SET(CMAKE_PREFIX_PATH "${CMAKE_INSTALL_PREFIX}" ${CMAKE_PREFIX_PATH})
ENDIF(CMAKE_INSTALL_PREFIX)

# Subdirectories
ADD_SUBDIRECTORY(doc)
ADD_SUBDIRECTORY(src)

# Doxygen
FIND_PACKAGE(Doxygen)
IF (DOXYGEN_FOUND)
  ADD_CUSTOM_TARGET (apidoc cp Doxyfile ${CMAKE_BINARY_DIR}/Doxyfile-build
    COMMAND echo "OUTPUT_DIRECTORY=${CMAKE_BINARY_DIR}" >> ${CMAKE_BINARY_DIR}/Doxyfile-build
    COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_BINARY_DIR}/Doxyfile-build
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
  ADD_CUSTOM_TARGET (apidoc-stable cp Doxyfile ${CMAKE_BINARY_DIR}/Doxyfile-stable
    COMMAND echo "OUTPUT_DIRECTORY=${CMAKE_BINARY_DIR}" >> ${CMAKE_BINARY_DIR}/Doxyfile-stable
    COMMAND echo "HTML_HEADER=header.html" >> ${CMAKE_BINARY_DIR}/Doxyfile-stable
    COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_BINARY_DIR}/Doxyfile-stable
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
ENDIF (DOXYGEN_FOUND)

# Packager
SET(CPACK_PACKAGE_NAME "libpappsomspp")
SET(CPACK_PACKAGE_VENDOR "PAPPSO Development Team")
SET(CPACK_PACKAGE_VERSION "${PAPPSOMSPP_VERSION}")
SET(CPACK_PACKAGE_VERSION_MAJOR "${PAPPSOMSPP_VERSION_MAJOR}")
SET(CPACK_PACKAGE_VERSION_MINOR "${PAPPSOMSPP_VERSION_MINOR}")
SET(CPACK_PACKAGE_VERSION_PATCH "${PAPPSOMSPP_VERSION_PATCH}")
SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "The PAPPSO C++ library for mass spectrometry")
SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING")
SET(CPACK_RESOURCE_FILE_AUTHORS "${CMAKE_SOURCE_DIR}/AUTHORS")
SET(CPACK_RESOURCE_FILE_INSTALL "${CMAKE_SOURCE_DIR}/INSTALL")
SET(CPACK_SOURCE_GENERATOR "TGZ")
SET(CPACK_SOURCE_IGNORE_FILES
 "CMakeFiles"
 "Makefile"
 "_CPack_Packages"
 "CMakeCache.txt"
 ".*\\\\.git"
 ".*\\\\.gz"
 ".*\\\\.deb"
 ".*\\\\.rpm"
 ".*\\\\.dmg"
 ".*\\\\..*\\\\.swp"
 "src/\\\\..*"
 "src/libbpp*"
 "debian/tmp"
 "debian/libbpp.*/"
 "debian/libbpp.*\\\\.so.*"
 "debian/libbpp.*\\\\.a"
 "debian/libbpp.*\\\\.substvars"
 "debian/libbpp.*\\\\.debhelper"
 "debian/debhelper\\\\.log"
 "html"
 "Core.tag"
 "Testing"
 "build/"
 "build-stamp"
 "install_manifest.txt"
 "DartConfiguration.tcl"
 ${CPACK_SOURCE_IGNORE_FILES}
)



#dch -Djessie "message"
#cmake ..
#make deb
# scp libpappsomspp* proteus.moulon.inra.fr:/var/www/apt/incoming
# reprepro -Vb /var/www/apt processincoming default
# apt-get remove libpappsomspp*
#
#  debuild -S -sa
# dput -f olivier-langella *changes


#dpkg-deb -x libpappsomspp-qt4_0.0.4-1_amd64.deb libpappsomspp-qt4_0.0.4-1
#dpkg-gensymbols -v0 -plibpappsomspp-qt4 -Plibpappsomspp-qt4_0.0.4-1 -Osymbols
#cp symbols ../debian/libpappsomspp-qt4.symbols


#dpkg-deb -x libpappsomspp-qt5_0.0.4-1_amd64.deb libpappsomspp-qt5_0.0.4-1
#dpkg-gensymbols -v0 -plibpappsomspp-qt5 -Plibpappsomspp-qt5_0.0.4-1 -Osymbols
#cp symbols ../debian/libpappsomspp-qt5.symbols


IF (MACOS)
  SET(CPACK_GENERATOR "Bundle")
ENDIF()

SET(CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
SET(CPACK_DEBSOURCE_PACKAGE_FILE_NAME "lib${CMAKE_PROJECT_NAME}_${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}.orig")
INCLUDE(CPack)

#This adds the 'dist' target
ADD_CUSTOM_TARGET(dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)
# 'clean' is not (yet) a first class target. However, we need to clean the directories before building the sources:
IF("${CMAKE_GENERATOR}" MATCHES "Make")
  ADD_CUSTOM_TARGET(make_clean
  COMMAND ${CMAKE_MAKE_PROGRAM} clean
  WORKING_DIRECTORY ${CMAKE_CURRENT_DIR}
  )
  ADD_DEPENDENCIES(dist make_clean)
ENDIF()

IF (UNIX)
#This creates deb packages:



	add_custom_target(targz
		cpack -G TGZ --config CPackSourceConfig.cmake && tar xvfz pappsomspp-${PAPPSOMSPP_VERSION}.tar.gz
		WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
		COMMENT "Creating .tar.gz" VERBATIM
	)


	add_custom_target(deb
		cd pappsomspp-${PAPPSOMSPP_VERSION} && dpkg-buildpackage
		DEPENDS targz
		WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
		COMMENT "Creating Debian package" VERBATIM
	)

	file(GLOB changesdebs "${CMAKE_BINARY_DIR}/pappsomspp_*.dsc")

	foreach(libfile ${changesdebs})
	    SET(changesdeb "${libfile}")
	endforeach(libfile)

	message ("changes debian file : ${changesdeb}")
	#lintian -IEi --pedantic tandem-mass_2013.06.15-1_amd64.changes
	add_custom_target(lintian
		lintian -IEi --pedantic ${changesdeb}
		DEPENDS deb
		WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
		COMMENT "lintian check" VERBATIM
	)
	
SET(DCH_VERSION "1")

add_custom_target(symbolsqt5
	dpkg-deb -x libpappsomspp-qt5_${PAPPSOMSPP_VERSION}-${DCH_VERSION}_amd64.deb libpappsomspp-qt5-untar && dpkg-gensymbols -v0 -plibpappsomspp-qt5 -Plibpappsomspp-qt5-untar -Osymbols && cp symbols ../debian/libpappsomspp-qt5.symbols
	WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
	COMMENT "symbolsqt5 " VERBATIM
)
	
add_custom_target(symbolsqt4
	dpkg-deb -x libpappsomspp-qt4_${PAPPSOMSPP_VERSION}-${DCH_VERSION}_amd64.deb libpappsomspp-qt4-untar && dpkg-gensymbols -v0 -plibpappsomspp-qt4 -Plibpappsomspp-qt4-untar -Osymbols && cp symbols ../debian/libpappsomspp-qt4.symbols
	WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
	COMMENT "symbolsqt4" VERBATIM
)
	
add_custom_target(symbols
	DEPENDS symbolsqt4 symbolsqt5
	WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
	COMMENT "symbols generation" VERBATIM
)
	
	
#dpkg-deb -x libpappsomspp-qt4_0.0.4-1_amd64.deb libpappsomspp-qt4_0.0.4-1
#dpkg-gensymbols -v0 -plibpappsomspp-qt4 -Plibpappsomspp-qt4_0.0.4-1 -Osymbols
#cp symbols ../debian/libpappsomspp-qt4.symbols


#dpkg-deb -x libpappsomspp-qt5_0.0.4-1_amd64.deb libpappsomspp-qt5_0.0.4-1
#dpkg-gensymbols -v0 -plibpappsomspp-qt5 -Plibpappsomspp-qt5_0.0.4-1 -Osymbols
#cp symbols ../debian/libpappsomspp-qt5.symbols

SET(CTEST_UPDATE_TYPE git)
SET(UPDATE_COMMAND "git")
SET(UPDATE_OPTIONS "")

ENABLE_TESTING()
INCLUDE(CTest)
IF (BUILD_TESTING)
  ADD_SUBDIRECTORY(test)
ENDIF(BUILD_TESTING)

# Install cmake module
INSTALL(FILES cmake_modules/FindPappsomspp.cmake DESTINATION share/cmake-3.0/Modules)


ENDIF(UNIX)

=== doc/CMakeLists.txt ===
find_package(Doxygen)
if(DOXYGEN_FOUND)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
add_custom_target(doc
${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/src
COMMENT "Generating API documentation with Doxygen" VERBATIM
)
INSTALL(DIRECTORY  ${CMAKE_CURRENT_BINARY_DIR}/html DESTINATION share/doc/libpappsomspp)

endif(DOXYGEN_FOUND)

=== src/CMakeLists.txt ===
# CMake script for PAPPSOms++ library
# Author: Olivier Langella
# Created: 03/03/2015

SET(pappsomspp_RCCS libpappsomsppresources.qrc)
# File list
SET(CPP_FILES
#	pappsomspp/test.cpp
	pappsomspp/utils.cpp
	pappsomspp/mass_range.cpp
	pappsomspp/amino_acid/aaBase.cpp
	pappsomspp/amino_acid/Aa.cpp
	pappsomspp/amino_acid/aamodification.cpp
 	pappsomspp/peptide/ion.cpp
 	pappsomspp/peptide/peptideinterface.cpp
	pappsomspp/peptide/peptide.cpp
	pappsomspp/peptide/peptidefragment.cpp
	pappsomspp/peptide/peptidefragmention.cpp
	pappsomspp/peptide/peptidefragmentionlistbase.cpp
	pappsomspp/peptide/peptidenaturalisotope.cpp
	pappsomspp/peptide/peptidenaturalisotopelist.cpp
	pappsomspp/peptide/peptidenaturalisotopeaverage.cpp
	pappsomspp/peptide/peptiderawfragmentmasses.cpp
	pappsomspp/peptide/peptidestrparser.cpp
	pappsomspp/protein/protein.cpp
	pappsomspp/protein/enzyme.cpp
	pappsomspp/protein/peptidesizefilter.cpp
	pappsomspp/protein/peptidebuilder.cpp
	pappsomspp/protein/peptidevariablemodificationbuilder.cpp
	pappsomspp/protein/peptidevariablemodificationreplacement.cpp
	pappsomspp/protein/peptidefixedmodificationbuilder.cpp
	pappsomspp/protein/peptidemodificatorbase.cpp
	pappsomspp/protein/peptidemodificatortee.cpp
	pappsomspp/protein/peptidexwildcard.cpp
	pappsomspp/protein/peptidemethioninremove.cpp
	pappsomspp/protein/peptidemodificatorpipeline.cpp
	pappsomspp/protein/peptidesemienzyme.cpp
	pappsomspp/spectrum/spectrum.cpp
	pappsomspp/spectrum/spectrumid.cpp
	pappsomspp/spectrum/qualifiedspectrum.cpp
	pappsomspp/msrun/msrunid.cpp
	pappsomspp/psm/morpheus/morpheusscore.cpp
	pappsomspp/psm/peakionmatch.cpp
	pappsomspp/psm/peakionisotopematch.cpp
	pappsomspp/psm/peptidespectrummatch.cpp
	pappsomspp/psm/peptideisotopespectrummatch.cpp
	pappsomspp/psm/xtandem/xtandemhyperscore.cpp
	pappsomspp/psm/xtandem/xtandemhyperscorebis.cpp
	pappsomspp/psm/xtandem/xtandemspectrumprocess.cpp
	pappsomspp/grouping/grpexperiment.cpp
	pappsomspp/grouping/grppeptide.cpp
	pappsomspp/grouping/grpprotein.cpp
	pappsomspp/grouping/grpgroup.cpp
	pappsomspp/grouping/grpsubgroup.cpp
	pappsomspp/grouping/grppeptideset.cpp
	pappsomspp/grouping/grpmappeptidetosubgroupset.cpp
	pappsomspp/grouping/grpsubgroupset.cpp
	pappsomspp/grouping/grpgroupingmonitor.cpp
	pappsomspp/xic/xic.cpp
	pappsomspp/xic/xicpeak.cpp
	pappsomspp/xic/qualifiedxic.cpp
	pappsomspp/xic/xicpeptideinterface.cpp
	pappsomspp/xic/xicpeptidefragmention.cpp
	pappsomspp/xic/xicpeptidefragmentionnaturalisotope.cpp
	pappsomspp/xic/filters/xicfilterspike.cpp
	pappsomspp/xic/filters/xicfiltersmoothing.cpp
	pappsomspp/xic/filters/xicfiltermax.cpp
	pappsomspp/xic/filters/xicfilterbackground.cpp
	pappsomspp/xic/detection/xicdetectionzivy.cpp
	pappsomspp/xic/detection/xicdetectionmoulon.cpp
	pappsomspp/fasta/fastareader.cpp
	pappsomspp/fasta/fastaoutputstream.cpp
	pappsomspp/obo/obopsimod.cpp
	pappsomspp/obo/filterobopsimodsink.cpp
	pappsomspp/obo/filterobopsimodtermaccession.cpp
	pappsomspp/obo/filterobopsimodtermlabel.cpp
	pappsomspp/obo/filterobopsimodtermdiffmono.cpp
	pappsomspp/obo/filterobopsimodtermname.cpp
  )

#set(CMAKE_INCLUDE_CURRENT_DIR ON)


IF (USEQT5)
  #qt5-default qtbase5-dev

  #IF (UNIX)
    FIND_PACKAGE( Qt5Core REQUIRED )
    FIND_PACKAGE( Qt5Concurrent REQUIRED )
    FIND_PACKAGE( Qt5Gui REQUIRED )
  #ENDIF (UNIX)
  
  MESSAGE ("Qt5Core_LIBRARIES ${Qt5Core_LIBRARIES}")
  MESSAGE ("QT_CORE_LIB ${QT_CORE_LIB}")
  
  #MESSAGE ("Qt5::Core ${Qt5::Core}")

  # generate rules for building source files from the resources
  QT5_ADD_RESOURCES(pappsomspp_RCC_SRCS ${pappsomspp_RCCS})
  # generate rules for building source files that moc generates
  #QT5_WRAP_CPP(QtApp_MOC_SRCS ${QtApp_MOCS})

  # Build the static lib
  ADD_LIBRARY(pappsomspp-static-qt5 STATIC ${CPP_FILES} ${pappsomspp_RCC_SRCS})
  target_include_directories (pappsomspp-static-qt5 PUBLIC ${Qt5Core_INCLUDES} ${Qt5Concurrent_INCLUDES} ${Qt5Gui_INCLUDES})
    
    SET_TARGET_PROPERTIES(pappsomspp-static-qt5
      PROPERTIES OUTPUT_NAME pappsomspp-qt5
      CLEAN_DIRECT_OUTPUT 1
      CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Core_EXECUTABLE_COMPILE_FLAGS} ${Qt5Concurrent_EXECUTABLE_COMPILE_FLAGS} ${Qt5Gui_EXECUTABLE_COMPILE_FLAGS}"
    )
  TARGET_LINK_LIBRARIES(pappsomspp-static-qt5 ${LIBS} ${Qt5Core_LIBRARIES} ${Qt5Concurrent_LIBRARIES} ${Qt5Gui_LIBRARIES})

  # Build the shared lib
  IF (NOT MINGW)
    ADD_LIBRARY(pappsomspp-shared-qt5 SHARED ${CPP_FILES} ${pappsomspp_RCC_SRCS})
    target_include_directories (pappsomspp-shared-qt5 PUBLIC ${Qt5Core_INCLUDES} ${Qt5Concurrent_INCLUDES} ${Qt5Gui_INCLUDES})
    SET_TARGET_PROPERTIES(pappsomspp-shared-qt5
      PROPERTIES OUTPUT_NAME pappsomspp-qt5
      CLEAN_DIRECT_OUTPUT 1
      VERSION ${PAPPSOMSPP_VERSION}
      SOVERSION ${PAPPSOMSPP_VERSION_MAJOR}
      CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Core_EXECUTABLE_COMPILE_FLAGS} ${Qt5Concurrent_EXECUTABLE_COMPILE_FLAGS} ${Qt5Gui_EXECUTABLE_COMPILE_FLAGS}"
      )
    TARGET_LINK_LIBRARIES(pappsomspp-shared-qt5 ${LIBS} ${Qt5Core_LIBRARIES} ${Qt5Concurrent_LIBRARIES} ${Qt5Gui_LIBRARIES})
    # Install libs
    INSTALL(TARGETS pappsomspp-static-qt5 pappsomspp-shared-qt5 DESTINATION lib${LIB_SUFFIX})
  ENDIF (NOT MINGW)

ENDIF(USEQT5)


IF (USEQT4)
  #libqt4-dev
  FIND_PACKAGE( Qt4 COMPONENTS QTCORE QTGUI REQUIRED )
  
  MESSAGE ("QT_DEFINITIONS ${QT_DEFINITIONS}" )
  MESSAGE ("QT_INCLUDE_DIR ${QT_INCLUDE_DIR}" )
  MESSAGE ("QT_QTCORE_INCLUDE_DIR ${QT_QTCORE_INCLUDE_DIR}" )
  

  # generate rules for building source files from the resources
  QT4_ADD_RESOURCES(pappsomspp_RCC_SRCS_QT4 ${pappsomspp_RCCS})
  # generate rules for building source files that moc generates
  #QT4_WRAP_CPP(QtApp_MOC_SRCS ${QtApp_MOCS})

  # Build the static lib
  ADD_LIBRARY(pappsomspp-static-qt4 STATIC ${CPP_FILES} ${pappsomspp_RCC_SRCS_QT4})
  target_include_directories (pappsomspp-static-qt4 PUBLIC ${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR} ${QT_QTGUI_INCLUDE_DIR})
  SET_TARGET_PROPERTIES(pappsomspp-static-qt4
    PROPERTIES OUTPUT_NAME pappsomspp-qt4
    CLEAN_DIRECT_OUTPUT 1
    #COMPILE_DEFINITIONS " ${QT_DEFINITIONS}"
    #INCLUDE_DIRECTORIES "${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR}"
    )
  TARGET_LINK_LIBRARIES(pappsomspp-static-qt4 ${LIBS} ${QT_QTCORE_LIBRARY} ${QT_QTGUI_LIBRARY})

  # Build the shared lib
  ADD_LIBRARY(pappsomspp-shared-qt4 SHARED ${CPP_FILES} ${pappsomspp_RCC_SRCS_QT4})
  target_include_directories (pappsomspp-shared-qt4 PUBLIC ${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR} ${QT_QTGUI_INCLUDE_DIR})
  SET_TARGET_PROPERTIES(pappsomspp-shared-qt4
    PROPERTIES OUTPUT_NAME pappsomspp-qt4
    CLEAN_DIRECT_OUTPUT 1
    VERSION ${PAPPSOMSPP_VERSION}
    SOVERSION ${PAPPSOMSPP_VERSION_MAJOR}
    #COMPILE_DEFINITIONS " ${QT_DEFINITIONS}"
    #INCLUDE_DIRECTORIES "${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR}"
    )
  TARGET_LINK_LIBRARIES(pappsomspp-shared-qt4 ${LIBS} ${QT_QTCORE_LIBRARY} ${QT_QTGUI_LIBRARY})

  # Install libs
  INSTALL(TARGETS pappsomspp-static-qt4 pappsomspp-shared-qt4 DESTINATION lib${LIB_SUFFIX})

ENDIF(USEQT4)


# Install headers
INSTALL(DIRECTORY pappsomspp/ DESTINATION include/pappsomspp FILES_MATCHING PATTERN "*.h")

IF (CMAKE_SYSTEM_NAME MATCHES "Windows")
    add_subdirectory("testwin64")
ENDIF(CMAKE_SYSTEM_NAME MATCHES "Windows")

=== test/CMakeLists.txt ===
# CMake script for PAPPSOms++ library
# Author: Olivier Langella
# Created: 03/03/2015 from the CMakeLists file of the Bio++ project

configure_file (config.h.cmake ${CMAKE_SOURCE_DIR}/test/config.h)

#apt-get install libpwiz-dev libboost-dev
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake_modules)
FIND_PACKAGE(Pwiz)
IF (Pwiz_FOUND)
  INCLUDE_DIRECTORIES( ${Pwiz_INCLUDE_DIR})
  FIND_PACKAGE(Boost REQUIRED)
  INCLUDE_DIRECTORIES( ${Boost_INCLUDE_DIRS})
ELSE (Pwiz_FOUND)
  MESSAGE("Proteowizard library not found")
  MESSAGE("did you apt-get install libpwiz-dev libboost-dev ?")
ENDIF (Pwiz_FOUND)
#CTEST_OUTPUT_ON_FAILURE=TRUE make test
#make test ARGS="-V"
#make test ARGS="-V -I 4,4"

#export LD_LIBRARY_PATH=/home/langella/developpement/git/pappsomspp/build/src:$LD_LIBRARY_PATH


#set(CMAKE_MODULE_PATH "/usr/share/cmake-3.0/Modules")
FIND_PACKAGE( Odsstream REQUIRED )
INCLUDE_DIRECTORIES(${ODSSTREAM_INCLUDE_DIR})



MACRO(TEST_FIND_LIBRARY OUTPUT_LIBS lib_name include_to_find)
  #start:
  FIND_PATH(${lib_name}_INCLUDE_DIR ${include_to_find})

  SET(${lib_name}_NAMES ${lib_name} ${lib_name}.lib ${lib_name}.dll)
  FIND_LIBRARY(${lib_name}_LIBRARY NAMES ${${lib_name}_NAMES})
  IF(${lib_name}_LIBRARY)
    MESSAGE("-- Library ${lib_name} found here:")
    MESSAGE("   includes: ${${lib_name}_INCLUDE_DIR}")
    MESSAGE("   dynamic libraries: ${${lib_name}_LIBRARY}")
    MESSAGE(WARNING "Library ${lib_name} is already installed in the system tree. Test will be built against it. This may lead to unexpected results. You may want to do 'make install' before 'make test', or remove the installed version.")
  ELSE()
    MESSAGE("${lib_name}_LIBRARY -L../src -l${lib_name}")
    MESSAGE("${lib_name}_INCLUDE_DIR ../src/")
    MESSAGE("${LIBS}")
    SET(${lib_name}_LIBRARY "-L../src -l${lib_name}")
    SET(${lib_name}_INCLUDE_DIR "../src/")
  ENDIF()
  INCLUDE_DIRECTORIES(${${lib_name}_INCLUDE_DIR})
  SET(${OUTPUT_LIBS} ${${OUTPUT_LIBS}} ${${lib_name}_LIBRARY})
ENDMACRO(TEST_FIND_LIBRARY)



# File list
SET(CPP_TEST_FILES
  saxparsers/xtandemresultshandler.cpp
  )
  

IF (USEQT5)
  IF (USEQT4)
     SET (USEQT5 0)
     SET (USEQT4 1)
  ENDIF(USEQT4)
ENDIF(USEQT5)

IF (USEQT5)
  #Find the bpp-core library library:
  TEST_FIND_LIBRARY(LIBS pappsomspp-qt5 pappsomspp/types.h pappsomspp/peptide/peptidenaturalisotopelist.h)

  FIND_PACKAGE( Qt5Core REQUIRED )
  FIND_PACKAGE( Qt5Xml REQUIRED )
  FIND_PACKAGE( Qt5Gui REQUIRED )
  INCLUDE_DIRECTORIES(${Qt5Core_INCLUDES} ${Qt5Xml_INCLUDES} ${Qt5Gui_INCLUDES})
  SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Core_EXECUTABLE_COMPILE_FLAGS}")
 
  set(QTLIBS ${Qt5Core_LIBRARIES} ${Qt5Xml_LIBRARIES} ${Qt5Gui_LIBRARIES})
  set(ODSLIBS ${ODSSTREAM_QT5_LIBRARY})
 
ENDIF(USEQT5)

IF (USEQT4)
  #Find the bpp-core library library:
  TEST_FIND_LIBRARY(LIBS pappsomspp-qt4 pappsomspp/types.h pappsomspp/peptide/peptidenaturalisotopelist.h)

  FIND_PACKAGE( Qt4 COMPONENTS QTCORE QTXML QTGUI REQUIRED )
  
  INCLUDE_DIRECTORIES(${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR} ${QT_QTXML_INCLUDE_DIR} ${QT_QTGUI_INCLUDE_DIR})
  set(QTLIBS "${LIBS} ${QT_QTCORE_LIBRARY} ${QT_QTXML_LIBRARY} ${QT_QTGUI_LIBRARY}")
  
  set(ODSLIBS ${ODSSTREAM_QT4_LIBRARY})
ENDIF(USEQT4)


message("qtlibs used for tests :  ${QTLIBS}")
  
   MESSAGE ("CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS}")
  MESSAGE ("LIBS ${LIBS}")


ADD_EXECUTABLE(test_fasta_reader test_fasta_reader.cpp)
TARGET_LINK_LIBRARIES(test_fasta_reader ${LIBS} ${QTLIBS})
ADD_TEST(test_fasta_reader "test_fasta_reader")


ADD_EXECUTABLE(test_protein test_protein.cpp)
TARGET_LINK_LIBRARIES(test_protein ${LIBS} ${QTLIBS})
ADD_TEST(test_protein "test_protein")

ADD_EXECUTABLE(test_xic test_xic.cpp)
TARGET_LINK_LIBRARIES(test_xic ${LIBS} ${QTLIBS} ${ODSLIBS})
ADD_TEST(test_xic "test_xic")


ADD_EXECUTABLE(test_massrange test_massrange.cpp)
TARGET_LINK_LIBRARIES(test_massrange ${LIBS} ${QTLIBS})
ADD_TEST(test_massrange "test_massrange")

ADD_EXECUTABLE(test_aa test_aa.cpp)
TARGET_LINK_LIBRARIES(test_aa ${LIBS} ${QTLIBS})
ADD_TEST(test_aa "test_aa")

ADD_EXECUTABLE(test_peptide test_peptide.cpp)
TARGET_LINK_LIBRARIES(test_peptide ${LIBS} ${QTLIBS})
ADD_TEST(test_peptide "test_peptide")

ADD_EXECUTABLE(test_peptidenaturalisotopelist test_peptidenaturalisotopelist.cpp)
TARGET_LINK_LIBRARIES(test_peptidenaturalisotopelist ${LIBS} ${QTLIBS})
ADD_TEST(test_peptidenaturalisotopelist "test_peptidenaturalisotopelist")


ADD_EXECUTABLE(test_natural_isotope_average test_natural_isotope_average.cpp)
TARGET_LINK_LIBRARIES(test_natural_isotope_average ${LIBS} ${QTLIBS})
ADD_TEST(test_natural_isotope_average "test_natural_isotope_average")


ADD_EXECUTABLE(test_peptidefragment test_peptidefragment.cpp)
TARGET_LINK_LIBRARIES(test_peptidefragment ${LIBS} ${QTLIBS})
ADD_TEST(test_peptidefragment "test_peptidefragment")

ADD_EXECUTABLE(test_fragmentationcid test_fragmentationcid.cpp)
TARGET_LINK_LIBRARIES(test_fragmentationcid ${LIBS} ${QTLIBS})
ADD_TEST(test_fragmentationcid "test_fragmentationcid")

#IF (FALSE) 
ADD_EXECUTABLE(test_big_hyperscore test_big_hyperscore.cpp ${CPP_TEST_FILES})
TARGET_LINK_LIBRARIES(test_big_hyperscore ${LIBS} ${QTLIBS})
ADD_TEST(test_big_hyperscore "test_big_hyperscore")
#ENDIF(FALSE)


ADD_EXECUTABLE(test_rawmasslist test_rawmasslist.cpp)
TARGET_LINK_LIBRARIES(test_rawmasslist ${LIBS} ${QTLIBS})
ADD_TEST(test_rawmasslist "test_rawmasslist")

IF (Pwiz_FOUND)

  ADD_EXECUTABLE(test_isotope_with_spectrum test_isotope_with_spectrum.cpp)
  TARGET_LINK_LIBRARIES(test_isotope_with_spectrum ${LIBS}  ${QTLIBS} ${Pwiz_LIBRARY} ${Boost_LIBRARIES})
  ADD_TEST(test_isotope_with_spectrum "test_isotope_with_spectrum")
  SET(TEST_LIST ${TEST_LIST} test_isotope_with_spectrum)
  
  ADD_EXECUTABLE(test_hyperscore test_hyperscore.cpp)
  TARGET_LINK_LIBRARIES(test_hyperscore ${LIBS} ${QTLIBS} ${Pwiz_LIBRARY} ${Boost_LIBRARIES})
  ADD_TEST(test_hyperscore "test_hyperscore")
  SET(TEST_LIST ${TEST_LIST} test_hyperscore)

  ADD_EXECUTABLE(test_xtandem_spectrum test_xtandem_spectrum.cpp)
  TARGET_LINK_LIBRARIES(test_xtandem_spectrum ${LIBS} ${QTLIBS} ${Pwiz_LIBRARY} ${Boost_LIBRARIES})
  ADD_TEST(test_xtandem_spectrum "test_xtandem_spectrum")
  SET(TEST_LIST ${TEST_LIST} test_xtandem_spectrum)

    ADD_EXECUTABLE(test_scan_15968 test_scan_15968.cpp)
  TARGET_LINK_LIBRARIES(test_scan_15968 ${LIBS} ${QTLIBS} ${Pwiz_LIBRARY} ${Boost_LIBRARIES})
  ADD_TEST(test_scan_15968 "test_scan_15968")
  SET(TEST_LIST ${TEST_LIST} test_scan_15968)

ENDIF(Pwiz_FOUND)

IF(UNIX)
  SET_PROPERTY(TEST  test_big_hyperscore test_xic test_protein test_fasta_reader test_massrange test_aa test_peptide test_peptidenaturalisotopelist  test_peptidefragment test_fragmentationcid ${TEST_LIST} test_natural_isotope_average test_rawmasslist PROPERTY ENVIRONMENT "LD_LIBRARY_PATH=$ENV{LD_LIBRARY_PATH}:../src")
ENDIF()

IF(WIN32)
  SET(ENV{PATH} "$ENV{PATH};..\\src")
ENDIF()

=== debian/changelog ===
libpappsomspp (0.2.35-1) jessie; urgency=medium

  * new grouping API

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Wed, 26 Apr 2017 21:17:09 +0200

libpappsomspp (0.2.34-1) jessie; urgency=medium

  * new peptides API to handle modification removal

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Mon, 24 Apr 2017 09:03:01 +0200

libpappsomspp (0.2.33-1) jessie; urgency=medium

  * better grouping, contaminant handler modified

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Tue, 18 Apr 2017 11:17:20 +0200

libpappsomspp (0.2.32-3) jessie; urgency=medium

  * better intensity ratio isotope determination

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Sat, 21 Jan 2017 12:13:24 +0100

libpappsomspp (0.2.32-1) jessie; urgency=medium

  * better spectrum API

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Tue, 20 Dec 2016 17:01:04 +0100

libpappsomspp (0.2.31-1) jessie; urgency=medium

  * new modification replacer in digestion API

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Wed, 07 Dec 2016 13:43:48 +0100

libpappsomspp (0.2.30-2) jessie; urgency=medium

  * digestion bug fixed

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Mon, 14 Nov 2016 21:52:40 +0100

libpappsomspp (0.2.30-1) jessie; urgency=medium

  * new digestion API

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Wed, 19 Oct 2016 21:50:47 +0200

libpappsomspp (0.2.29-1) jessie; urgency=medium

  * new peptide digestion pipeline

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Tue, 13 Sep 2016 13:55:11 +0200

libpappsomspp (0.2.28-1) jessie; urgency=medium

  * don't handle xic sink pointer lifetime

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Tue, 30 Aug 2016 17:12:30 +0200

libpappsomspp (0.2.27-1) jessie; urgency=medium

  * new ion types

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Thu, 25 Aug 2016 07:48:16 +0200

libpappsomspp (0.2.26-1) jessie; urgency=medium

  * new features in xtandem hyperscore computations

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Tue, 23 Aug 2016 10:06:12 +0200

libpappsomspp (0.2.25-1) jessie; urgency=medium

  * improving spectrum process for tandem hyperscore computation

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Fri, 19 Aug 2016 10:54:19 +0200

libpappsomspp (0.2.24-1) jessie; urgency=medium

  * new API to digest protein, new documentation

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Fri, 15 Jul 2016 16:01:40 +0200

libpappsomspp (0.2.23-1) jessie; urgency=medium

  * formula one

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Sun, 03 Jul 2016 23:20:42 +0200

libpappsomspp (0.2.22-1) jessie; urgency=medium

  * XML id added in msrun

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Sat, 25 Jun 2016 17:34:19 +0200

libpappsomspp (0.2.21-1) jessie; urgency=medium

  * computing PSI OBO modification masses using the diff formula

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Fri, 24 Jun 2016 21:53:34 +0200

libpappsomspp (0.2.20-1) jessie; urgency=medium

  * compute amino acid mass using the chemical formula

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Wed, 22 Jun 2016 21:47:53 +0200

libpappsomspp (0.2.19-1) jessie; urgency=medium

  * proton vs protium bug fixed

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Wed, 22 Jun 2016 16:25:05 +0200

libpappsomspp (0.2.18-1) jessie; urgency=medium

  * disctinction between proton and protium mass

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Wed, 22 Jun 2016 15:34:14 +0200

libpappsomspp (0.2.17-1) jessie; urgency=medium

  * amino acid precision goes now to 4 digits instead of previous 3
    digits

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Wed, 22 Jun 2016 13:48:34 +0200

libpappsomspp (0.2.16-1) jessie; urgency=medium

  * new syntax to limit modifications per site

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Sun, 12 Jun 2016 08:12:44 +0200

libpappsomspp (0.2.15-1) jessie; urgency=medium

  * new API to build peptide modification pipeline from strings

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Sat, 11 Jun 2016 22:15:09 +0200

libpappsomspp (0.2.14-1) jessie; urgency=medium

  * final fix into massrange

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Fri, 20 May 2016 22:31:50 +0200

libpappsomspp (0.2.13-1) jessie; urgency=medium

  * bug fix on PAPPSO mass range build with upper and lower precision

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Wed, 18 May 2016 15:25:20 +0200

libpappsomspp (0.2.12-1) jessie; urgency=medium

  * construct MassRange with upper and lower precisions

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Mon, 02 May 2016 16:40:31 +0200

libpappsomspp (0.2.11-1) jessie; urgency=medium

  * get highest and lowest mass of MassRange

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Thu, 28 Apr 2016 15:14:20 +0200

libpappsomspp (0.2.10-1) jessie; urgency=medium

  * peptide modification API modified, new Xic MS point distance
    function added

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Sat, 09 Apr 2016 22:52:33 +0200

libpappsomspp (0.2.9-1) jessie; urgency=medium

  * copy constructor bug fixed in Xic isotope

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Thu, 17 Mar 2016 08:46:10 +0100

libpappsomspp (0.2.8-2) jessie; urgency=medium

  * copy constructor added

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Mon, 14 Mar 2016 21:18:37 +0100

libpappsomspp (0.2.8-1) jessie; urgency=medium

  * Precision pointers, xic detection methods

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Thu, 10 Mar 2016 12:13:15 +0100

libpappsomspp (0.2.7-1) jessie; urgency=medium

  * combinations cached
  * parsing PSI MOD istope labels
  * semi tryptic digestion

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Mon, 08 Feb 2016 09:06:57 +0100

libpappsomspp (0.2.6-2) jessie; urgency=medium



=== debian/control ===
Source: libpappsomspp
Maintainer: Olivier Langella <olivier.langella@moulon.inra.fr>
Homepage: http://pappso.inra.fr/bioinfo
Section: libs
Priority: optional
Build-Depends: debhelper (>= 9), cmake (>= 2.6), libqt4-dev (>= 4.6.3), qt5-default ,libpwiz-dev, libboost-dev, libodsstream-dev, doxygen
Standards-Version: 3.9.4

Package: libpappsomspp-qt4
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: C++ library to handle proteomic data
 libpappsomspp provides a simple API to handle peptides, spectrum,
 ions, amino acid mofifications...

Package: libpappsomspp-qt5
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: C++ library to handle proteomic data
 libpappsomspp provides a simple API to handle peptides, spectrum,
 ions, amino acid mofifications...

Package: libpappsomspp-qt5-dbgsym
Auto-Built-Package: debug-symbols
Priority: extra
Section: debug 
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: C++ library to handle proteomic data
 libpappsomspp provides a simple API to handle peptides, spectrum,
 ions, amino acid mofifications...

Package: libpappsomspp-qt4-dbgsym
Auto-Built-Package: debug-symbols
Priority: extra
Section: debug 
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: C++ library to handle proteomic data
 libpappsomspp provides a simple API to handle peptides, spectrum,
 ions, amino acid mofifications...

Package: libpappsomspp-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libpappsomspp-qt4 (= ${binary:Version}), libpappsomspp-qt5 (= ${binary:Version}),
         ${misc:Depends}
Description: development files for the proteomic PAPPSOms++ library
 libpappsomspp provides a simple API to handle peptides, spectrum,
 ions, amino acid mofifications. the development files contains a cmake module
 to easily find and configure PAPPSOms++ library

Package: libpappsomspp-doc
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends}
Description: doxygen documentation of the PAPPSOms++ library
 libpappsomspp provides a simple API to handle peptides, spectrum,
 ions, amino acid mofifications.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export DESTDIR=$(CURDIR)/debian/tmp

#%:
#	dh $@ --buildsystem=cmake --parallel

configure: configure-stamp
configure-stamp:
	cmake -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE=Release -DUSEQT4=1 -DUSEQT5=1 .
	dh_testdir
	# Add here commands to configure the package.

	touch configure-stamp


build: build-stamp

build-stamp: configure-stamp
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE)
	$(MAKE) doc
	$(MAKE) test
	#docbook-to-man debian/beads.sgml > beads.1

	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp CMakeCache.txt

	# Add here commands to clean up after the build process.
	-$(MAKE) clean

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	$(MAKE) DESTDIR=$(DESTDIR) install


# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_installdocs
	dh_installexamples
	dh_install --sourcedir=$(DESTDIR) --list-missing
#	dh_install
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb
	dh_makeshlibs

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure
